/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <link.h>

PLUGIN_DECLARE_STD_IMPORTS;
proc_demux_add_handler add_demux;

uint _PLUGIN_INIT (p_plugin_in in, p_plugin_out out)
{
	PLUGIN_CHECK_PARAMS(in);
	PLUGIN_IMPORT_STD;
	
	add_demux=in->add_demux;

	PLUGIN_NAME("proto/link");
	PLUGIN_DESC("Some of the more popular data link protocols")
	PLUGIN_VERS(1,1);
		
	if ( !(add_demux(LTYPE_LINK, demux_callback)) ) {
		return PLUGIN_ERR_FAIL;
	}else{	
		return PLUGIN_ERR_OK;
	}
}

/* This is where we would cleanup our shit */
uint _PLUGIN_UNLOAD (void)
{
	return PLUGIN_ERR_OK;
}

/* This is our actual demultiplex handler */
#define NPROTO_IP	0x0800
int demux_callback(p_packet p, int layer)
{
	switch (p->layer[layer].id) {
		case NULL:
		case DLT_RAW:
			p->layer[layer].name = "Raw IP";
			p->layer[layer+1].h.raw = &p->data;
			p->layer[layer+1].id = NPROTO_IP;
			break;

		case DLT_EN10MB:
			p->layer[layer].name = "Ethernet II";
			p->layer[layer+1].id = 
				ntohs(p->layer[layer].h.mac->proto);
			p->layer[layer+1].h.raw = p->layer[layer].h.raw
			       + sizeof(struct ethhdr);
			break;
		
		default:
			return DEMUX_UNKNOWN;
	}

	p->layer[layer+1].type=LTYPE_NET;
	return DEMUX_OK;
}
